// JSCTSABT: Just Some Checks, This Should Always Be True

var stringBundle;

var bakProfilesSettings;
var bakDefaultProfile;
var bakMainButtonEnabled;
var bakAutoDetectionAtStart;
var bakAutoDetectionAtGetMails;
var bakAutoDetectionAtIntervals;
var bakIntervals;
var bakDetectionRules;
var bakDelayEnabled;
var bakDelay;
var bakDelayOnlyDeferredAccounts;
var bakNativeGetMailButtonOptionsEnabled;
var bakDebugMode;
var bakDebugModeToFile;
var bakDebugFileName;

var accountKeysList = new Array();
var accountsCount = 0;
var selectedAccountsCount = 0;

var profilesSettingsList = new Array();
var currentProfileIdx = 0;
var selectedAccountKey = "";
var selectedAccount = null;
var profilesListChanged = false;

var detectionRulesArray = null;
var detectionRulesListBoxChanged = false;

function sendMessageToConsole(source, message, msgType)
{
	msgType = ( typeof(msgType) !== "undefined" ) ? msgType : "information";

	GetSelectedMails.debugMode = document.getElementById("debugModeCheckBox").checked;
	GetSelectedMails.debugModeToFile = document.getElementById("debugModeToFileCheckBox").checked;
	GetSelectedMails.debugFileName = unescape(document.getElementById("debugFileName").value); // decodes string

	switch ( msgType ) {
		case "warning":
			GetSelectedMails.localConsole.logWarning(source, message);
			break;
		case "error":
			GetSelectedMails.localConsole.logError(source, message);
			break;
		case "information":
		default:
			GetSelectedMails.localConsole.logInformation(source, message);
			break;
	}
}

function onOpenSettingsDialog(openSettingsDialogRef)
{
	var profileIdx = -1;

	// gets index of given 'open settings dialog' profile
	// '^': start of string
	// '[^0-9]+': anything but a figure 1 or several times
	// '([0-9]+)': 1 number (index) -> group #1
	// '$': end of string
	var openSettingsDialogIdx = openSettingsDialogRef.match(new RegExp("^[^0-9]+([0-9]+)$"));

	if ( openSettingsDialogIdx != null ) {
		profileIdx = openSettingsDialogIdx[1];
	}

	return profileIdx;
}

function initializeSettings()
{
	// initializations
	stringBundle = document.getElementById("getSelectedMailsOptionsStringBundle");
	createAccountKeysList();
	initializeProfilesSettings();
	checkProfiles();

	// tab 'profiles'
	bakProfilesSettings = document.getElementById("profilesSettings").value;
	document.getElementById("profilesListChanged").value = false;
	profilesListChanged = false;

	// tab 'default profile'
	bakDefaultProfile = document.getElementById("defaultProfile").value;
	bakMainButtonEnabled = document.getElementById("mainButtonEnabled").value;

	currentProfileIdx = ( window.arguments != null ) ? onOpenSettingsDialog(window.arguments[0]) : bakDefaultProfile;
	if ( (currentProfileIdx < 0) || (currentProfileIdx >= GetSelectedMails.maximumProfilesCount) || (currentProfileIdx >= profilesSettingsList.length) ) { // checks profile index given as parameter is inside limits
		currentProfileIdx = bakDefaultProfile;
	}

	createAccountsCheckBoxes();
	fillMenuLists();
	loadProfile(currentProfileIdx);

	// tab 'default profile' > auto detection
	bakAutoDetectionAtStart = document.getElementById("autoDetectionAtStart").value;
	bakAutoDetectionAtGetMails = document.getElementById("autoDetectionAtGetMails").value;
	bakAutoDetectionAtIntervals = document.getElementById("autoDetectionAtIntervals").value;
	bakIntervals = document.getElementById("intervals").value;
	bakDetectionRules = document.getElementById("detectionRules").value;

	if ( (bakDetectionRules == null) || (bakDetectionRules == "") ) { // if detection rules list is empty
		detectionRulesArray = new Array();
	}
	else {
		detectionRulesArray = GetSelectedMails.JSONparse(bakDetectionRules, GetSelectedMails.preProcessLoadSettings, new Array("sIP", "eIP", "pId"));
	}

	detectionRulesListBoxChanged = false;
	resetDetectedProfileMenuList();
	initializeDetectionRulesList();
	initializeDetectionRuleInputBoxes();

	selectedDetectionRuleIdx = -1;

	// tab 'miscellaneous' > 'messages retrieval delay'
	bakDelayEnabled = document.getElementById("delayEnabled").value;
	bakDelay = document.getElementById("delay").value;
	bakDelayOnlyDeferredAccounts = document.getElementById("delayOnlyDeferredAccounts").value;

	onClickDelayEnabledCheckBox(bakDelayEnabled);

	// tab 'miscellaneous' > 'options of native get mail button'
	bakNativeGetMailButtonOptionsEnabled = document.getElementById("nativeGetMailButtonOptionsEnabled").value;

	// tab 'miscellaneous' > group 'help and support'
	bakDebugMode = document.getElementById("debugMode").value;
	bakDebugModeToFile = document.getElementById("debugModeToFile").value;
	bakDebugFileName = unescape(document.getElementById("debugFileName").value); // decodes string
	document.getElementById("debugModeToFileTextBox").value = bakDebugFileName;

	onClickDebugModeCheckBox(bakDebugMode);

	//
	sendMessageToConsole("options.initializeSettings", "Settings have been initialized");
}

function saveSettings()
{
	// tab 'profiles'
	saveProfile(currentProfileIdx); // saves current profile

	var profilesSettings = GetSelectedMails.JSONstringify(profilesSettingsList, GetSelectedMails.preProcessSaveProfileSettings, new Array("name", "title")); // converts profiles settings list into JSON string
	document.getElementById("profilesSettings").value = profilesSettings; // saves profiles settings

	document.getElementById("profilesListChanged").value = ( profilesListChanged || (bakProfilesSettings != profilesSettings) ); // if anything has changed flags it

	sendMessageToConsole("options.saveSettings", "Profile settings are: '" + profilesSettings + "'");

	// tab 'default profile'
	var defaultProfile = document.getElementById("defaultProfileMenuList").selectedIndex;
	document.getElementById("defaultProfile").value = defaultProfile; // saves default profile index (this should be done after profiles update)

	sendMessageToConsole("options.saveSettings", "Default profile is #" + defaultProfile + " '" + unescape(profilesSettingsList[defaultProfile].name) + "'");

	// tab 'default profile' > auto detection
	var detectionRulesStr = GetSelectedMails.JSONstringify(detectionRulesArray, GetSelectedMails.preProcessSaveSettings, new Array("sIP", "eIP", "pId"));
	if ( detectionRulesStr != document.getElementById("detectionRules").value ) { // if any change has been made to detection rules list
		sendMessageToConsole("options.saveSettings", "Detection rules list has been modified: " + detectionRulesStr);

		document.getElementById("detectionRules").value = detectionRulesStr; // saves detection rules list
	}
	else {
		sendMessageToConsole("options.saveSettings", "Detection rules list has not been modified");
	}

	// tab 'miscellaneous' > group 'help and support'
	if ( document.getElementById("debugModeToFileTextBox").value == "" ) {
		document.getElementById("debugModeToFile").value = false;
	}
	document.getElementById("debugFileName").value = escape(document.getElementById("debugModeToFileTextBox").value); // encodes string

	//
	sendMessageToConsole("options.saveSettings", "Settings have been saved");
}

function resetSettings()
{
	// initializations
	createAccountKeysList();
	initializeProfilesSettings();
	checkProfiles();

	// tab 'profiles'
	document.getElementById("profilesSettings").value = bakProfilesSettings;
	document.getElementById("profilesListChanged").value = false;
	profilesListChanged = false;

	// tab 'default profile'
	document.getElementById("defaultProfile").value = bakDefaultProfile;
	document.getElementById("mainButtonEnabled").value = bakMainButtonEnabled;

	currentProfileIdx = ( window.arguments != null ) ? onOpenSettingsDialog(window.arguments[0]) : bakDefaultProfile;
	if ( (currentProfileIdx < 0) || (currentProfileIdx >= GetSelectedMails.maximumProfilesCount) || (currentProfileIdx >= profilesSettingsList.length) ) { // checks profile index given as parameter is inside limits
		currentProfileIdx = bakDefaultProfile;
	}

	reinitializeMenuLists();
	fillMenuLists();
	loadProfile(currentProfileIdx);

	// tab 'default profile' > auto detection
	document.getElementById("autoDetectionAtStart").value = bakAutoDetectionAtStart;
	document.getElementById("autoDetectionAtGetMails").value = bakAutoDetectionAtGetMails;
	document.getElementById("autoDetectionAtIntervals").value = bakAutoDetectionAtIntervals;
	document.getElementById("intervals").value = bakIntervals;

	document.getElementById("detectionRules").value = bakDetectionRules;

	if ( (bakDetectionRules == null) || (bakDetectionRules == "") ) { // if detection rules list is empty
		detectionRulesArray = new Array();
	}
	else {
		detectionRulesArray = GetSelectedMails.JSONparse(bakDetectionRules, GetSelectedMails.preProcessLoadSettings, new Array("sIP", "eIP", "pId"));
	}

	detectionRulesListBoxChanged = false;
	initializeDetectionRulesList();

	selectedDetectionRuleIdx = -1;

	// tab 'miscellaneous' > 'messages retrieval delay'
	document.getElementById("delayEnabled").value = bakDelayEnabled;
	document.getElementById("delay").value = bakDelay;
	document.getElementById("delayOnlyDeferredAccounts").value = bakDelayOnlyDeferredAccounts;

	onClickDelayEnabledCheckBox(bakDelayEnabled);

	// tab 'miscellaneous' > 'options of native get mail button'
	document.getElementById("nativeGetMailButtonOptionsEnabled").value = bakNativeGetMailButtonOptionsEnabled;

	// tab 'miscellaneous' > group 'help and support'
	document.getElementById("debugMode").value = bakDebugMode;
	document.getElementById("debugModeToFile").value = bakDebugModeToFile;
	document.getElementById("debugModeToFileTextBox").value = bakDebugFileName;

	onClickDebugModeCheckBox(bakDebugMode);

	//
	sendMessageToConsole("options.resetSettings", "Settings have been resetted");
}

// 'profiles' functions
function initializeProfilesSettings()
{
	var profilesSettings = document.getElementById("profilesSettings").value;
	if ( profilesSettings == "" ) {
		profilesSettings = "[]";
	}
	profilesSettingsList = GetSelectedMails.JSONparse(profilesSettings, GetSelectedMails.preProcessLoadProfileSettings, new Array("name", "title")); // parses profiles settings as JSON string

	sendMessageToConsole("options.initializeProfilesSettings", profilesSettings);
	sendMessageToConsole("options.initializeProfilesSettings", profilesSettingsList.length + " profiles have been loaded");
}

function createAccountKeysList()
{
	var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"]
							.getService(Components.interfaces.nsIMsgAccountManager);
	var accounts = new GetSelectedMails.VirtualArray(accountManager.accounts, Components.interfaces.nsIMsgAccount); // accounts list
	var account = null; // account object
	var accountServer = null; // related server

	var accountKeyRgx = null;
	var accountKey = "";

	accountKeysList = {};

	for ( var idx = 0 ; idx < accounts.count() ; idx++ ) { // for each account
		account = accounts.queryAt(idx); // gets account object
		accountServer = account.incomingServer; // gets related server

		if ( (accountServer != null) && (accountServer.type != "none") ) { // if account is not "Local Folder"
			accountKeyRgx = account.key.match(new RegExp("^account([0-9]+)$"));

			if ( accountKeyRgx != null ) {
				accountKey = "a" + accountKeyRgx[1];
				accountKeysList[accountKey] = accountServer.prettyName;
			}
			else {
				sendMessageToConsole("options.createAccountKeysList", account.key + " is not a valid account key", "warning");
			}
		}
	}
}

function checkProfiles()
{
	var defaultProfileName = "";
	var defaultTitle = "";

	if ( profilesSettingsList.length == 0 ) { // if no profile is defined
		// creation of a default profile
		defaultProfileName = stringBundle.getString('profileDefaultPrefix') + " 1"; // creates a default profile name
		defaultTitle = stringBundle.getString('customButtonDefaultTitle') + " '" + defaultProfileName + "'";

		profilesSettingsList.push(new GetSelectedMails.ProfileSettings("p0", defaultProfileName, false, defaultTitle, "", {}, {}, {}, {}, {}, {}, {}, {}, {}, false)); // adds a new profile settings object
	}

	for ( var idx in profilesSettingsList ) { // for each profile
		// initialization of profile (if necessary)
		if ( profilesSettingsList[idx] == null ) {
			profilesSettingsList[idx] = {};
		}

		// initialization of profile's settings (if necessary)
		defaultProfileName = stringBundle.getString('profileDefaultPrefix') + " " + (currentProfileIdx + 1); // creates a default profile name based on profile index

		if ( profilesSettingsList[idx].name == null ) {
			profilesSettingsList[idx].name = defaultProfileName;
		}

		if ( profilesSettingsList[idx].button == null ) {
			profilesSettingsList[idx].button = false;
		}

		if ( profilesSettingsList[idx].title == null ) {
			defaultTitle = stringBundle.getString('customButtonDefaultTitle') + " '" + defaultProfileName + "'";
			profilesSettingsList[idx].title = defaultTitle;
		}

		if ( profilesSettingsList[idx].icon == null ) {
			profilesSettingsList[idx].icon = "";
		}

		if ( profilesSettingsList[idx].accounts == null ) {
			profilesSettingsList[idx].accounts = {};
		}

		if ( profilesSettingsList[idx].hdrs == null ) {
			profilesSettingsList[idx].hdrs = {};
		}

		if ( profilesSettingsList[idx].hdrsDflt == null ) {
			profilesSettingsList[idx].hdrsDflt = {};
		}

		if ( profilesSettingsList[idx].srv == null ) {
			profilesSettingsList[idx].srv = {};
		}

		if ( profilesSettingsList[idx].srvName == null ) {
			profilesSettingsList[idx].srvName = {};
		}

		if ( profilesSettingsList[idx].srvDflt == null ) {
			profilesSettingsList[idx].srvDflt = {};
		}

		if ( profilesSettingsList[idx].prt == null ) {
			profilesSettingsList[idx].prt = {};
		}

		if ( profilesSettingsList[idx].prtNmbr == null ) {
			profilesSettingsList[idx].prtNmbr = {};
		}

		if ( profilesSettingsList[idx].prtDflt == null ) {
			profilesSettingsList[idx].prtDflt = {};
		}

		if ( profilesSettingsList[idx].sendBGet == null ) {
			profilesSettingsList[idx].sendBGet = false;
		}

		// initialization of profile's accounts settings (if necessary)
		for ( var accountKey in accountKeysList ) { // for each account
			if ( profilesSettingsList[idx].accounts[accountKey] == null ) {
				// @todo: don't know if this initialization is really useful or not
				profilesSettingsList[idx].accounts[accountKey] = false;
			}
		}
	}
}

function reinitializeMenuLists()
{
	var selectedProfileMenuPopUp = document.getElementById("selectedProfileMenuPopUp");
	var defaultProfileMenuPopUp = document.getElementById("defaultProfileMenuPopUp");

	// clearance of accounts menupopup
	if ( selectedProfileMenuPopUp != null ) { // (JSCTSABT) if accounts menupopup exists
		while ( selectedProfileMenuPopUp.firstChild ) {
			selectedProfileMenuPopUp.removeChild(selectedProfileMenuPopUp.firstChild);
		};
	}

	// clearance of default profile menupopup
	if ( defaultProfileMenuPopUp != null ) { // (JSCTSABT) if default profile menupopup exists
		while ( defaultProfileMenuPopUp.firstChild ) {
			defaultProfileMenuPopUp.removeChild(defaultProfileMenuPopUp.firstChild);
		};
	}
}

function fillMenuLists()
{
	for ( var idx = 0 ; idx < profilesSettingsList.length ; idx++ ) { // for each profile
		// add of a menu item for profile selection menulist
		var selectedProfileMenuItem = document.createElement("menuitem"); // creates a new menuitem
		selectedProfileMenuItem.setAttribute('id', "selectedProfileMenuItem-" + idx);
		selectedProfileMenuItem.setAttribute('value', profilesSettingsList[idx].id);
		selectedProfileMenuItem.setAttribute('label', profilesSettingsList[idx].name);
		document.getElementById("selectedProfileMenuPopUp").appendChild(selectedProfileMenuItem); // appends new menuitem to profiles menulist

		// add of a menu item for default profile menulist
		var defaultProfileMenuItem = document.createElement("menuitem"); // creates a new menuitem
		defaultProfileMenuItem.setAttribute('id', "defaultProfileMenuItem-" + idx);
		defaultProfileMenuItem.setAttribute('value', profilesSettingsList[idx].id);
		defaultProfileMenuItem.setAttribute('label', profilesSettingsList[idx].name);
		document.getElementById("defaultProfileMenuPopUp").appendChild(defaultProfileMenuItem); // appends new menuitem to default profile menulist
	}

	document.getElementById("selectedProfileMenuList").selectedIndex = currentProfileIdx; // selects default profile in profiles menulist
	document.getElementById("defaultProfileMenuList").selectedIndex = document.getElementById("defaultProfile").value; // selects default profile in default profile menulist
}

function createAccountsCheckBoxes()
{
	var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"]
							.getService(Components.interfaces.nsIMsgAccountManager);
	var accounts = new GetSelectedMails.VirtualArray(accountManager.accounts, Components.interfaces.nsIMsgAccount); // accounts list
	var account = null; // account object
	var accountServer = null; // related server

	var accountKeyRgx = null;
	var accountKey = "";

	var username = "";
	var hostname = "";

	var optionsCommands = document.getElementById("getSelectedMailsOptionsCmds");

	var newCheckBox = null;
	var newButton = null;
	var newCommand = null;
	var newSpacer = null;

	var newRow = null;

	for ( var idx = 0 ; idx < accounts.count() ; idx++ ) { // for each account
		account = accounts.queryAt(idx); // gets account object
		accountServer = account.incomingServer; // gets related server

		if ( (accountServer != null) && (accountServer.type != "none") ) { // if account is not "Local Folder"
			accountsCount++;

			username = ( (accountServer.realUsername != null) && (accountServer.realUsername != "") ) ?
							accountServer.realUsername :
							( (accountServer.username != null) && (accountServer.username != "") ) ?
								accountServer.username :
								"<undefined>";
			hostname = ( (accountServer.realHostName != null) && (accountServer.realHostName != "") ) ?
							accountServer.realHostName :
							( (accountServer.hostName != null) && (accountServer.hostName != "") ) ?
								accountServer.hostName :
								"<undefined>";

			accountKeyRgx = account.key.match(new RegExp("^account([0-9]+)$"));

			if ( accountKeyRgx != null ) {
				accountKey = "a" + accountKeyRgx[1];

				// checkbox
				newRow = document.createElement("row"); // creates a new row
				newCheckBox = document.createElement("checkbox"); // creates a new checkbox
				newCheckBox.setAttribute('id', "accountsSelectionCheckBox-" + accountKey); // sets checkbox id

				var idName = ( account.defaultIdentity != null ) ? " : " + account.defaultIdentity.identityName : "";
				newCheckBox.setAttribute('label', accountServer.prettyName + idName); // sets account name and identity name as checkbox label

				var asHostName = ( accountServer.type != "rss" ) ? " / " + hostname : "";
				var asPort = ( accountServer.prt != -1 ) ? " / " + accountServer.port : "";
				newCheckBox.setAttribute('tooltiptext', username + asHostName + " / " + accountServer.type + asPort); // sets additional information as checkbox tooltip text

				newCheckBox.setAttribute('checked', false); // initializes checkbox state as 'false'

				if ( optionsCommands != null ) { // (JSCTSABT) if graphical objects exist
					newCommand = document.createElement("command"); // creates a new command
					newCommand.setAttribute('id', "accountsSelectionCheckBoxCmd-" + accountKey); // sets id
					newCommand.addEventListener("command", function() { onClickAccountsSelectionCheckBox(this.id); }, false); // sets related action

					optionsCommands.appendChild(newCommand); // appends command to commands

					newCheckBox.setAttribute('command', "accountsSelectionCheckBoxCmd-" + accountKey);
				}

				newRow.appendChild(newCheckBox); // adds checkbox to row

				// button
				newButton = document.createElement("button"); // creates a new button
				newButton.setAttribute('id', "accountsSelectionButton-" + accountKey); // sets button id
				newButton.setAttribute('image', "chrome://GetSelectedMails/skin/icon_settings.png"); // sets button image
				newButton.setAttribute('style', "min-width:10px;"); // sets button style

				if ( accountServer.type == "rss" ) {
					newButton.setAttribute('disabled', true);
				}
				else {
					newButton.setAttribute('tooltiptext', stringBundle.getString('settingsOfAccountSta') + accountServer.prettyName + stringBundle.getString('settingsOfAccountEnd')); // sets button tooltip text
				}

				if ( optionsCommands != null ) { // (JSCTSABT) if graphical objects exist
					newCommand = document.createElement("command"); // creates a new command
					newCommand.setAttribute('id', "accountsSelectionButtonCmd-" + accountKey); // sets id
					newCommand.addEventListener("command", function() { onClickAccountsSelectionButton(this.id); }, false); // sets related action

					optionsCommands.appendChild(newCommand); // appends command to commands

					newButton.setAttribute('command', "accountsSelectionButtonCmd-" + accountKey);
				}

				newRow.appendChild(newButton); // adds button to row

				// spacer
				// this spacer is useful if vertical scrollbar is displayed: in this case, button is overlayed by scrollbar and is not fully visible
				// this trick allows to add an invisible item (spacer) which is the one overlayed by scrollbar
				// its width is computed automatically once all items have been added
				newSpacer = document.createElement("spacer"); // creates a new spacer

				newRow.appendChild(newSpacer); // adds spacer to row

				document.getElementById("accountsHBoxRows").appendChild(newRow); // appends row (checkbox + button + spacer) to accounts groupbox
			}
			else {
				sendMessageToConsole("options.createAccountsCheckBoxes", account.key + " is not a valid account key", "warning");
			}
		}
	}

	// setting of width of spacer
	if ( newSpacer != null ) {
		var spacerWidth = document.getElementById("accountsHBoxRows").scrollWidth - document.getElementById("accountsHBoxRows").clientWidth + 1;
		newSpacer.setAttribute('style', "width: " + spacerWidth + "px");
	}
}

function setProfileAccountsCheckBoxes(state)
{
	var accountsHBoxRows = document.getElementById("accountsHBoxRows");

	if ( (accountsHBoxRows != null) && accountsHBoxRows.hasChildNodes() ) { // (JSCTSABT) if accounts groupbox exists and has children
		var xulElement = accountsHBoxRows.firstChild; // gets first element

		while ( xulElement != null ) { // while there is a next element
			if ( (xulElement.nodeName == "row") && xulElement.hasChildNodes() ) {
				var rowElement = xulElement.firstChild; // gets first element

				while ( rowElement != null ) { // while there is a next row element
					if ( rowElement.nodeName == "checkbox" ) { // if child is a checkbox (= profile accounts selection checkboxes)
						rowElement.checked = state; // unchecks checkbox
					}

					rowElement = rowElement.nextSibling; // gets next row element
				};
			}

			xulElement = xulElement.nextSibling; // gets next element
		};
	}

	selectedAccountsCount = ( state ) ? accountsCount : 0;
}

function reinitializeProfileGraphicalObjects()
{
	document.getElementById("profileNameTextBox").value = "";

	document.getElementById("profileCustomButtonCheckBox").checked = false;
	document.getElementById("profileCustomButtonTitleTextBox").value = "";
	document.getElementById("profileCustomButtonIconMenuList").selectedIndex = 0;

	// accounts box
	document.getElementById("selectAllAccountsCheckBox").checked = false;
	setProfileAccountsCheckBoxes(false);

	// account settings box
	selectedAccountKey = "";
	selectedAccount = null;

	document.getElementById("accountSettingsCaption").label = stringBundle.getString('accountSettings');

	document.getElementById("headersFetchingLabel").disabled = true;
	document.getElementById("headersFetchingMenuList").selectedIndex = 0;
	document.getElementById("headersFetchingMenuList").disabled = true;
	document.getElementById("headersFetchingDefaultCheckBox").checked = false;
	document.getElementById("headersFetchingDefaultCheckBox").disabled = true;

	document.getElementById("serverLabel").disabled = true;
	document.getElementById("serverCheckBox").checked = false;
	document.getElementById("serverCheckBox").disabled = true;
	document.getElementById("serverNameTextBox").value = "";
	document.getElementById("serverNameTextBox").disabled = true;
	document.getElementById("serverDefaultCheckBox").checked = false;
	document.getElementById("serverDefaultCheckBox").disabled = true;

	document.getElementById("portLabel").disabled = true;
	document.getElementById("portCheckBox").checked = false;
	document.getElementById("portCheckBox").disabled = true;
	document.getElementById("portNumberTextBox").value = 0;
	document.getElementById("portNumberTextBox").disabled = true;
	document.getElementById("portDefaultCheckBox").checked = false;
	document.getElementById("portDefaultCheckBox").disabled = true;

	// miscellaneous box
	document.getElementById("sendBeforeGetCheckBox").checked = false;
}

function onClickSelectAllAccountsCheckBox(state)
{
	setProfileAccountsCheckBoxes(state);
}

function onClickProfileAddButton()
{
	saveProfile(document.getElementById("selectedProfileMenuList").selectedIndex); // saves current profile

	if ( profilesSettingsList.length < GetSelectedMails.maximumProfilesCount ) {
		currentProfileIdx = profilesSettingsList.length; // gets total profiles count

		// search for first profile index ("p" + number)
		var profileIdRgx = null;
		var currentProfileId = "";
		var currentProfileIdx2 = 0;

		for ( var idx = 0 ; (idx < profilesSettingsList.length) /*&& (currentProfileId == "")*/ ; idx++ ) { // for each profile
			profileIdRgx = profilesSettingsList[idx].id.match(new RegExp("^p([0-9]+)$"));

			if ( profileIdRgx != null ) {
				if ( parseInt(currentProfileIdx2) < parseInt(profileIdRgx[1]) ) {
					currentProfileIdx2 = profileIdRgx[1];
				}
			}
		}

		currentProfileId = "p" + ++currentProfileIdx2;

		var defaultProfileName = stringBundle.getString('profileDefaultPrefix') + " " + (currentProfileIdx + 1); // creates a default profile name based on profile index

		// add of a new menuitem for profile selection menulist
		var selectedProfileMenuItem = document.createElement("menuitem"); // creates a new menuitem
		selectedProfileMenuItem.setAttribute('id', "selectedProfileMenuItem-" + currentProfileIdx);
		selectedProfileMenuItem.setAttribute('value', currentProfileId);
		selectedProfileMenuItem.setAttribute('label', defaultProfileName);
		document.getElementById("selectedProfileMenuPopUp").appendChild(selectedProfileMenuItem); // appends new menuitem to profile selection menulist

		// add of a new menuitem for default profile menulist
		var defaultProfileMenuItem = document.createElement("menuitem"); // creates a new menuitem
		defaultProfileMenuItem.setAttribute('id', "defaultProfileMenuItem-" + currentProfileIdx);
		defaultProfileMenuItem.setAttribute('value', currentProfileId);
		defaultProfileMenuItem.setAttribute('label', defaultProfileName);
		document.getElementById("defaultProfileMenuPopUp").appendChild(defaultProfileMenuItem); // appends new menuitem to default profile menulist

		document.getElementById("selectedProfileMenuList").selectedIndex = currentProfileIdx; // selects new profile

		reinitializeProfileGraphicalObjects(); // clears display of new profile

		document.getElementById("profileNameTextBox").value = defaultProfileName;
		document.getElementById("profileIdLabel").value = currentProfileId;

		var defaultTitle = stringBundle.getString('customButtonDefaultTitle') + " '" + defaultProfileName + "'";
		document.getElementById("profileCustomButtonTitleTextBox").value = defaultTitle;

		profilesSettingsList.push(new GetSelectedMails.ProfileSettings(currentProfileId, defaultProfileName, false, defaultTitle, "", {}, {}, {}, {}, {}, {}, {}, {}, {}, false)); // adds a new profile settings object

		onClickProfileCustomButtonCheckBox(document.getElementById("profileCustomButtonCheckBox").checked);

		resetDetectedProfileMenuList();

		//
		sendMessageToConsole("options.onClickProfileAddButton", "Profile #" + currentProfileIdx + " '" + defaultProfileName + "' created");
	}
	else {
		sendMessageToConsole("options.onClickProfileAddButton", "Maximum profiles count reached", "warning");
	}
}

function onClickProfileUpButton()
{
	var selectedProfileMenuList = document.getElementById("selectedProfileMenuList");
	var defaultProfileMenuList = document.getElementById("defaultProfileMenuList");

	saveProfile(currentProfileIdx);

	if ( (selectedProfileMenuList != null) && (defaultProfileMenuList != null) ) { // (JSCTSABT)
		if ( currentProfileIdx > 0 ) { // if selected item is not the first one
			var otherProfileIdx = currentProfileIdx - 1;
			swapProfileButton(selectedProfileMenuList, defaultProfileMenuList, currentProfileIdx, otherProfileIdx, "down");
		}
	}
}

function onClickProfileDownButton()
{
	var selectedProfileMenuList = document.getElementById("selectedProfileMenuList");
	var defaultProfileMenuList = document.getElementById("defaultProfileMenuList");

	saveProfile(currentProfileIdx);

	if ( (selectedProfileMenuList != null) && (defaultProfileMenuList != null) ) { // (JSCTSABT)
		if ( (currentProfileIdx >= 0) && (currentProfileIdx < profilesSettingsList.length - 1) ) { // if selected item is not the last one
			var otherProfileIdx = parseInt(currentProfileIdx) + 1;
			swapProfileButton(selectedProfileMenuList, defaultProfileMenuList, currentProfileIdx, otherProfileIdx, "down");
		}
	}
}

function swapProfileButton(selectedProfileMenuList, defaultProfileMenuList, profile1Idx, profile2Idx, msg)
{
	var selectedProfileMenuItemToMoveDown = document.getElementById("selectedProfileMenuItem-" + profile1Idx);
	var selectedProfileMenuItemToMoveUp = document.getElementById("selectedProfileMenuItem-" + profile2Idx);

	var defaultProfileMenuItemToMoveDown = document.getElementById("defaultProfileMenuItem-" + profile1Idx);
	var defaultProfileMenuItemToMoveUp = document.getElementById("defaultProfileMenuItem-" + profile2Idx);

	if ( (selectedProfileMenuItemToMoveDown != null) && (selectedProfileMenuItemToMoveUp != null) && (defaultProfileMenuItemToMoveDown != null) && (defaultProfileMenuItemToMoveUp != null) ) { // (JSCTSABT)
		// update of selected profile menulist
		var tempProfileId = selectedProfileMenuItemToMoveDown.value; // backups value
		var tempProfileName = selectedProfileMenuItemToMoveDown.label; // backups label
		selectedProfileMenuItemToMoveDown.value = selectedProfileMenuItemToMoveUp.value;
		selectedProfileMenuItemToMoveDown.label = selectedProfileMenuItemToMoveUp.label;
		selectedProfileMenuItemToMoveUp.value = tempProfileId;
		selectedProfileMenuItemToMoveUp.label = tempProfileName;

		selectedProfileMenuList.selectedIndex = profile2Idx;

		// update of default profile menulist
		var tempSelectedIdx = defaultProfileMenuList.selectedIndex;

		var tempProfileName = defaultProfileMenuItemToMoveDown.label; // backups label
		defaultProfileMenuItemToMoveDown.label = defaultProfileMenuItemToMoveUp.label;
		defaultProfileMenuItemToMoveUp.label = tempProfileName;

		if ( tempSelectedIdx == profile2Idx ) {
			defaultProfileMenuList.selectedIndex = profile1Idx;
		}
		else if ( tempSelectedIdx == profile1Idx ) {
			defaultProfileMenuList.selectedIndex = profile2Idx;
		}

		// update of profiles settings list
		var tempProfile = new GetSelectedMails.ProfileSettings(profilesSettingsList[profile2Idx]); // copies object
		profilesSettingsList[profile2Idx] = profilesSettingsList[profile1Idx];
		profilesSettingsList[profile1Idx] = tempProfile;

		currentProfileIdx = profile2Idx; // selects moved item again

		resetDetectedProfileMenuList();

		//
		sendMessageToConsole("options.swapProfileButton", "Profile " + tempProfileId + " / '" + tempProfileName + "' moved " + msg + " to #" + profile2Idx);

		profilesListChanged = true;
	}
}

function onClickProfileDeleteButton()
{
	var selectedProfileIdx = currentProfileIdx; // gets selected profile index
	var selectedProfileName = profilesSettingsList[selectedProfileIdx].name; // gets selected profile name

	var deleteFlag = GetSelectedMails.displayConfirmDialog(stringBundle.getString('beforeProfileDeletionSta') + selectedProfileName + stringBundle.getString('beforeProfileDeletionEnd'));

	if ( deleteFlag ) { // displays a confirmation dialog, and if 'ok' is selected
		var profilesCnt = profilesSettingsList.length; // gets total profiles count

		var selectedProfileMenuItem = document.getElementById("selectedProfileMenuItem-" + selectedProfileIdx); // gets selected profile element

		var defaultProfileIdx = document.getElementById("defaultProfileMenuList").selectedIndex; // gets selected default profile index

		var lastProfileMenuItem = document.getElementById("selectedProfileMenuItem-" + (profilesCnt - 1)); // gets last accounts menu item
		var lastDefaultProfileMenuItem = document.getElementById("defaultProfileMenuItem-" + (profilesCnt - 1)); // gets last profile menu item

		if ( (selectedProfileMenuItem != null) && (lastProfileMenuItem != null) && (lastDefaultProfileMenuItem != null) ) { // (JSCTSABT) if menuitems exist
			if ( profilesCnt > 1 ) { // if there is more than one profile left
				// rotation of profiles settings so that deleted profile is crushed
				for ( var idx = selectedProfileIdx ; idx < profilesCnt - 1 ; idx++ ) { // for each profile between deleted one and penultimate one
					profilesSettingsList[idx] = profilesSettingsList[idx + 1]; // sets current profile settings with next one settings

					document.getElementById("selectedProfileMenuItem-" + idx).label = document.getElementById("selectedProfileMenuItem-" + (idx + 1)).label; // updates menu item label in profiles list
					document.getElementById("defaultProfileMenuItem-" + idx).label = document.getElementById("defaultProfileMenuItem-" + (idx + 1)).label; // updates menu item label in default profile list
				}

				profilesSettingsList.pop(); // removes last profile

				document.getElementById("selectedProfileMenuPopUp").removeChild(lastProfileMenuItem);
				document.getElementById("defaultProfileMenuPopUp").removeChild(lastDefaultProfileMenuItem);

				resetDetectedProfileMenuList();
				initializeDetectionRulesList();

				//
				sendMessageToConsole("options.onClickProfileDeleteButton", "Profile #" + selectedProfileIdx + " '" + selectedProfileName + "' deleted");

				// handling when last profile is selected
				if ( selectedProfileIdx == profilesCnt - 1 ) { // if last profile is selected
					selectedProfileIdx--;
					document.getElementById("selectedProfileMenuList").selectedIndex = selectedProfileIdx; // selects an existing profile (previous one)
				}

				loadProfile(selectedProfileIdx);
				currentProfileIdx = selectedProfileIdx;

				if ( defaultProfileIdx == profilesCnt - 1 ) {
					document.getElementById("defaultProfileMenuList").selectedIndex = defaultProfileIdx - 1; // selects an existing default profile (previous one)
				}
			}
		}
	}
}

function onClickAccountsSelectionCheckBox(objId)
{
	var selectedAccountKey = objId.substring(objId.indexOf("-") + 1); // gets account key

	var value = ( document.getElementById("accountsSelectionCheckBox-" + selectedAccountKey).checked ) ? +1 : -1;
	selectedAccountsCount += value;

	document.getElementById("selectAllAccountsCheckBox").checked = ( selectedAccountsCount == accountsCount );

	sendMessageToConsole("options.onClickAccountsSelectionCheckBox", "selection of accounts: " + selectedAccountsCount + " / " + accountsCount);
}

function onClickAccountsSelectionButton(objId)
{
	var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"]
							.getService(Components.interfaces.nsIMsgAccountManager);
	var accounts = new GetSelectedMails.VirtualArray(accountManager.accounts, Components.interfaces.nsIMsgAccount); // accounts list
	var account = null;
	var accountServer = null; // related server

	var headersFetchingMenuList = document.getElementById("headersFetchingMenuList");
	var headersFetchingDefaultCheckBox = document.getElementById("headersFetchingDefaultCheckBox");

	var serverCheckBox = document.getElementById("serverCheckBox");
	var serverNameTextBox = document.getElementById("serverNameTextBox");
	var serverDefaultCheckBox = document.getElementById("serverDefaultCheckBox");

	var portCheckBox = document.getElementById("portCheckBox");
	var portNumberTextBox = document.getElementById("portNumberTextBox");
	var portDefaultCheckBox = document.getElementById("portDefaultCheckBox");

	var headersFetchingValue = null;
	var headersFetchingDefaultValue = null;

	var serverValue = null;
	var serverNameValue = null;
	var serverDefaultValue = null;

	var accountKeyRgx = null;

	var portValue = null;
	var portNumberValue = null;
	var portDefaultValue = null;

	var headersFetchingSettingsEnabled = false;
	var serverSettingsEnabled = true; // maybe for latter use
	var portSettingsEnabled = true; // maybe for latter use

	// saving of settings for previously selected account
	if ( selectedAccountKey != "" ) { // if an account was previously selected
		saveAccountSettings(currentProfileIdx, selectedAccountKey); // saves account settings for current profile

		sendMessageToConsole("options.onClickAccountsSelectionButton", "Settings for account '" + selectedAccountKey + "' of profile #" + currentProfileIdx + " '" + profilesSettingsList[currentProfileIdx].name + "' has been saved");
	}

	// loading of settings for current account
	selectedAccountKey = objId.substring(objId.indexOf("-") + 1); // gets account key
	selectedAccount = null;

	for ( var idx = 0 ; (idx < accounts.count()) && (selectedAccount == null) ; idx++ ) { // for each account
		account = accounts.queryAt(idx); // gets account object

		accountKeyRgx = account.key.match(new RegExp("^account([0-9]+)$"));
		if ( accountKeyRgx != null ) {
			if ( "a" + accountKeyRgx[1] == selectedAccountKey ) {
				selectedAccount = account;
			}
		}
	}

	if ( selectedAccount != null ) {
		accountServer = selectedAccount.incomingServer; // gets related server

		headersFetchingSettingsEnabled = ( (accountServer.type != "imap") && (accountServer.type != "nntp") ); // 'fetch headers only' is not a valid parameter for 'imap' and 'nntp' accounts

		document.getElementById("accountSettingsCaption").label = stringBundle.getString('accountSettings') + ": " + profilesSettingsList[currentProfileIdx].name + " > " + accountKeysList[selectedAccountKey]; // updates groupbox title

		// loading of headers fetching settings for current account
		if ( (headersFetchingMenuList != null) && (headersFetchingDefaultCheckBox != null) ) { // (JSCTSABT) if headers fetching menulist and checkbox exist
			if ( headersFetchingSettingsEnabled ) {
				// retrieval of stored values
				headersFetchingValue = profilesSettingsList[currentProfileIdx].hdrs[selectedAccountKey];
				if ( (headersFetchingValue == null) || (headersFetchingValue < 0 ) || (headersFetchingValue > 2 ) ) {
					headersFetchingValue = 0;
				}

				headersFetchingDefaultValue = profilesSettingsList[currentProfileIdx].hdrsDflt[selectedAccountKey];
				if ( headersFetchingDefaultValue == null ) {
					headersFetchingDefaultValue = false;
				}

				// updates gui
				document.getElementById("headersFetchingLabel").disabled = false;

				headersFetchingMenuList.disabled = false;
				headersFetchingMenuList.selectedIndex = headersFetchingValue;

				headersFetchingDefaultCheckBox.disabled = ( headersFetchingValue == 0 );
				headersFetchingDefaultCheckBox.checked = headersFetchingDefaultValue;
			}
			else {
				document.getElementById("headersFetchingLabel").disabled = true;
				headersFetchingMenuList.disabled = true;
				headersFetchingMenuList.selectedIndex = 0;
				headersFetchingDefaultCheckBox.disabled = true;
				headersFetchingDefaultCheckBox.checked = false;
			}
		}

		// loading of server settings for current account
		if ( (serverCheckBox != null) && (serverNameTextBox != null) && (serverDefaultCheckBox != null) ) { // (JSCTSABT) if server checkboxes and textbox exist
			if ( serverSettingsEnabled ) {
				// retrieval of stored values
				serverValue = profilesSettingsList[currentProfileIdx].srv[selectedAccountKey];
				if ( serverValue == null ) {
					serverValue = false;
				}

				serverNameValue = profilesSettingsList[currentProfileIdx].srvName[selectedAccountKey];
				if ( (serverNameValue == null) || (serverNameValue == "") ) {
					serverNameValue = ( accountServer.realHostName != "" ) ?
										accountServer.realHostName
										:
										accountServer.hostName;
				}

				serverDefaultValue = profilesSettingsList[currentProfileIdx].srvDflt[selectedAccountKey];
				if ( serverDefaultValue == null ) {
					serverDefaultValue = false;
				}

				// updates gui
				document.getElementById("serverLabel").disabled = false;

				serverCheckBox.disabled = false;
				serverCheckBox.checked = serverValue;

				onClickServerCheckBox(serverValue);

				serverNameTextBox.value = serverNameValue;
				serverDefaultCheckBox.checked = serverDefaultValue;
			}
			else {
				document.getElementById("serverLabel").disabled = true;
				serverCheckBox.disabled = true;
				serverCheckBox.checked = false;
				onClickServerCheckBox(false);
				serverNameTextBox.value = "";
				serverDefaultCheckBox.checked = false;
			}
		}

		// loading of port settings for current account
		if ( (portCheckBox != null) && (portNumberTextBox != null) && (portDefaultCheckBox != null) ) { // (JSCTSABT) if port checkboxes and textbox exist
			if ( portSettingsEnabled ) {
				// retrieval of stored values
				portValue = profilesSettingsList[currentProfileIdx].prt[selectedAccountKey];
				if ( portValue == null ) {
					portValue = false;
				}

				portNumberValue = profilesSettingsList[currentProfileIdx].prtNmbr[selectedAccountKey];
				if ( (portNumberValue == null) || (portNumberValue == 0) ) {
					portNumberValue = accountServer.port;
				}

				portDefaultValue = profilesSettingsList[currentProfileIdx].prtDflt[selectedAccountKey];
				if ( portDefaultValue == null ) {
					portDefaultValue = false;
				}

				// updates gui
				document.getElementById("portLabel").disabled = false;

				portCheckBox.disabled = false;
				portCheckBox.checked = portValue;

				onClickPortCheckBox(portValue);

				portNumberTextBox.value = portNumberValue;
				portDefaultCheckBox.checked = portDefaultValue;
			}
			else {
				document.getElementById("portLabel").disabled = true;
				portCheckBox.disabled = true;
				portCheckBox.checked = false;
				onClickPortCheckBox(false);
				portNumberTextBox.value = 0;
				portDefaultCheckBox.checked = false;
			}
		}

		sendMessageToConsole("options.onClickAccountsSelectionButton", "Settings for account '" + selectedAccountKey + "' of profile #" + currentProfileIdx + " '" + profilesSettingsList[currentProfileIdx].name + "' has been loaded");
	}
	else {
		selectedAccountKey = "";

		sendMessageToConsole("options.onClickAccountsSelectionButton", "Account '" + selectedAccountKey + "' not found", "warning");
	}
}

function onChangeSelectedProfile(selProfileIdx)
{
	saveProfile(currentProfileIdx);

	if ( currentProfileIdx != selProfileIdx ) { // if current profile has changed
		loadProfile(selProfileIdx);
	}

	currentProfileIdx = selProfileIdx;
}

function loadProfile(profileIdx)
{
	var accountsSelectionCheckBox = null;
	var accountsSelectionValue = null;

	reinitializeProfileGraphicalObjects();

	// display of profile name
	document.getElementById("profileNameTextBox").value = profilesSettingsList[profileIdx].name;
	document.getElementById("profileIdLabel").value = profilesSettingsList[profileIdx].id;

	// loading of custom icon settings for current account
	document.getElementById("profileCustomButtonCheckBox").checked = profilesSettingsList[profileIdx].button;

	if ( profilesSettingsList[profileIdx].title == null ) {
		var profileName = ( profilesSettingsList[profileIdx].name != "" ) ? profilesSettingsList[profileIdx].name : stringBundle.getString('profileDefaultPrefix') + " " + (profileIdx + 1);
		profilesSettingsList[profileIdx].title = stringBundle.getString('customButtonDefaultTitle') + " '" + profileName + "'";
	}
	document.getElementById("profileCustomButtonTitleTextBox").value = profilesSettingsList[profileIdx].title;

	var menuListItems = document.getElementById("profileCustomButtonIconMenuPopUp").children;
	for ( var idx = 0 ; idx < menuListItems.length ; idx++ ) {
		if ( menuListItems[idx].value == profilesSettingsList[profileIdx].icon ) {
			document.getElementById("profileCustomButtonIconMenuList").selectedIndex = idx;
		}
	}

	// display of accounts selection setting
	for ( var accountKey in accountKeysList ) { // for each account
		// loading of accounts selection for current account
		accountsSelectionCheckBox = document.getElementById("accountsSelectionCheckBox-" + accountKey); // gets related selection checkbox
		accountsSelectionValue = profilesSettingsList[profileIdx].accounts[accountKey];

		if ( (accountsSelectionCheckBox != null) && (accountsSelectionValue != null) ) { // (JSCTSABT) if accounts selection checkbox exists and if account has been found in accounts selection value
			accountsSelectionCheckBox.checked = accountsSelectionValue;

			if ( accountsSelectionValue ) {
				selectedAccountsCount++;
			}
		}
	}

	document.getElementById("selectAllAccountsCheckBox").checked = ( selectedAccountsCount == accountsCount );

	document.getElementById("sendBeforeGetCheckBox").checked = profilesSettingsList[profileIdx].sendBGet;

	onClickProfileCustomButtonCheckBox(document.getElementById("profileCustomButtonCheckBox").checked);

	sendMessageToConsole("options.loadProfile", "Selected settings for profile #" + profileIdx + " loaded: '" + GetSelectedMails.JSONstringify(profilesSettingsList[profileIdx]) + "'");
}

function saveProfile(profileIdx)
{
	var profileIdLabel = document.getElementById("profileIdLabel");
	var profileNameTextBox = document.getElementById("profileNameTextBox");
	var profileCustomButtonCheckBox = document.getElementById("profileCustomButtonCheckBox");
	var profileCustomButtonTitleTextBox = document.getElementById("profileCustomButtonTitleTextBox");
	var profileCustomButtonIconMenuList = document.getElementById("profileCustomButtonIconMenuList");
	var accountsHBoxRows = document.getElementById("accountsHBoxRows");
	var sendBeforeGetCheckBox = document.getElementById("sendBeforeGetCheckBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	var profileNameChanged = false;

	if ( selectedAccountKey != "" ) {
		saveAccountSettings(profileIdx, selectedAccountKey);
	}

	if ( (profileIdx >= 0) && (profileIdx < profilesSettingsList.length) && (profileIdLabel != null) && (profileNameTextBox != null) && (profileCustomButtonCheckBox != null) && (profileCustomButtonTitleTextBox != null) && (profileCustomButtonIconMenuList != null) && (detectedProfileMenuList != null) && (detectionRulesListBox != null) ) { // (JSCTSABT) if graphical objects exist
		var profileId = profileIdLabel.value;

		// saving of profile name
		var profileName = profileNameTextBox.value;
		profileNameChanged = ( profileName != profilesSettingsList[profileIdx].name );
		profilesSettingsList[profileIdx].name = profileName;

		if ( profileNameChanged ) { // if name of profile has been changed
			resetDetectedProfileMenuList();

			// update of profile name if this profile was selected in detected profile list
			if ( profilesSettingsList[profileIdx].id == detectedProfileMenuList.value ) {
				detectedProfileMenuList.value = profileId;
			}

			// update of profile name in detectection rules list
			for ( var idx = 0 ; idx < detectionRulesListBox.getRowCount() ; idx++ ) { // for each detection rule of detection rules listbox
				if ( profilesSettingsList[profileIdx].id == detectionRulesListBox.getItemAtIndex(idx).children[2].getAttribute('value') ) {
					detectionRulesListBox.getItemAtIndex(idx).children[2].setAttribute('label', profileName);
				}
			}
		}

		// saving of custom icon settings
		profilesSettingsList[profileIdx].button = profileCustomButtonCheckBox.checked;
		profilesSettingsList[profileIdx].title = profileCustomButtonTitleTextBox.value;
		profilesSettingsList[profileIdx].icon = profileCustomButtonIconMenuList.selectedItem.value;

		// saving of accounts selection and headers fetching setting
		var accountsSelectionCheckBox = null;
		var accountsSelection = "";
		var accountsSelectionObj = {}; // initializes associative array (associative arrays are objects in javascript)

		for ( var accountKey in accountKeysList ) { // for each account
			// saving of accounts selection for current account
			accountsSelectionCheckBox = document.getElementById("accountsSelectionCheckBox-" + accountKey); // gets related selection checkbox
			if ( accountsSelectionCheckBox != null ) { // (JSCTSABT) if accounts selection checkbox exists
				accountsSelectionObj[accountKey] = accountsSelectionCheckBox.checked; // stores account key
			}
		}

		profilesSettingsList[profileIdx].accounts = accountsSelectionObj;

		// saving of miscellaneous settings
		profilesSettingsList[profileIdx].sendBGet = sendBeforeGetCheckBox.checked;

		// update of menulists
		document.getElementById("selectedProfileMenuItem-" + profileIdx).label = profileName; // updates menu item label in profiles list
		document.getElementById("defaultProfileMenuItem-" + profileIdx).label = profileName; // updates menu item label in default profile list

		sendMessageToConsole("options.saveProfile", "Selected settings for profile #" + profileIdx + " (" + profilesSettingsList[profileIdx].id + ") written: '" + GetSelectedMails.JSONstringify(profilesSettingsList[profileIdx]) + "'");
	}
}

function saveAccountSettings(profileIdx, selAccount)
{
	var headersFetchingMenuList = document.getElementById("headersFetchingMenuList");
	var headersFetchingDefaultCheckBox = document.getElementById("headersFetchingDefaultCheckBox");

	var serverCheckBox = document.getElementById("serverCheckBox");
	var serverNameTextBox = document.getElementById("serverNameTextBox");
	var serverDefaultCheckBox = document.getElementById("serverDefaultCheckBox");

	var portCheckBox = document.getElementById("portCheckBox");
	var portNumberTextBox = document.getElementById("portNumberTextBox");
	var portDefaultCheckBox = document.getElementById("portDefaultCheckBox");

	var serverNameValue = "";
	var portNumberValue = 0;

	if ( (headersFetchingMenuList != null) && (headersFetchingDefaultCheckBox != null) && (serverNameTextBox != null) && (serverCheckBox != null) && (serverDefaultCheckBox != null) && (portNumberTextBox != null) && (portCheckBox != null) && (portDefaultCheckBox != null) ) { // (JSCTSABT)
		// headers fetching
		profilesSettingsList[profileIdx].hdrs[selAccount] = headersFetchingMenuList.selectedIndex; // updates headers fetching value
		profilesSettingsList[profileIdx].hdrsDflt[selAccount] = headersFetchingDefaultCheckBox.checked; // updates headers fetching default value

		// server
		serverNameValue = serverNameTextBox.value; // backups server name value (usefull for server checkbox)
		profilesSettingsList[profileIdx].srvName[selAccount] = serverNameTextBox.value; // updates server name value
		profilesSettingsList[profileIdx].srv[selAccount] = ( serverCheckBox.checked && (serverNameValue != "") ); // updates server value
		profilesSettingsList[profileIdx].srvDflt[selAccount] = serverDefaultCheckBox.checked; // updates server default value

		// port
		portNumberValue = portNumberTextBox.value; // backups port number (useful for port checkbox: that's why port number is saved before port checkbox value)
		profilesSettingsList[profileIdx].prtNmbr[selAccount] = parseInt(portNumberTextBox.value); // updates port number
		profilesSettingsList[profileIdx].prt[selAccount] = ( portCheckBox.checked && (portNumberValue > 0) ); // updates port value
		profilesSettingsList[profileIdx].prtDflt[selAccount] = portDefaultCheckBox.checked; // updates port default value
	}
}

function onClickProfileCustomButtonCheckBox(state)
{
	document.getElementById("profileCustomButtonTitleLabel").disabled = !state;
	document.getElementById("profileCustomButtonTitleTextBox").disabled = !state;
	document.getElementById("profileCustomButtonIconLabel").disabled = !state;
	document.getElementById("profileCustomButtonIconMenuList").disabled = !state;

	var profileCustomButtonIconMenuList = document.getElementById("profileCustomButtonIconMenuList");

	if ( profileCustomButtonIconMenuList != null ) { // (JSCTSABT) if accounts groupbox exists and has children
		var selValue = profileCustomButtonIconMenuList.selectedItem.value;
		var profileCustomButtonIconMenuItem = document.getElementById("profileCustomButtonIcon_" + selValue);

		if ( profileCustomButtonIconMenuItem != null ) {
			var colorImg = ( state ) ? "GetSelectedMails_" + selValue + "_sm.png" : "GetSelectedMails__disabled_sm.png";
			profileCustomButtonIconMenuItem.setAttribute('image', "chrome://GetSelectedMails/skin/" + colorImg);
		}
	}
}

function onChangeHeadersFetchingValue(value)
{
	document.getElementById("headersFetchingDefaultCheckBox").disabled = ( value == 0 );
}

function onClickServerCheckBox(state)
{
	document.getElementById("serverNameTextBox").disabled = !state;
	document.getElementById("serverDefaultCheckBox").disabled = !state;
}

function onClickPortCheckBox(state)
{
	document.getElementById("portNumberTextBox").disabled = !state;
	document.getElementById("portDefaultCheckBox").disabled = !state;
}

// 'auto detection' functions
function resetDetectedProfileMenuList()
{
	clearDetectedProfileMenuList();
	fillDetectedProfileMenuList();
}

function clearDetectedProfileMenuList()
{
	var detectedProfileMenuPopUp = document.getElementById("detectedProfileMenuPopUp");

	if ( detectedProfileMenuPopUp != null ) { // (JSCTSABT)
		// clearance of existing items
		while ( detectedProfileMenuPopUp.firstChild ) {
			detectedProfileMenuPopUp.removeChild(detectedProfileMenuPopUp.firstChild);
		}

		// add of a first "empty"-like item (to avoid graphical artefacts when choosing an actual profile in the menulist)
		var emptyMenuItem = document.createElement("menuitem"); // creates a new menuitem
		emptyMenuItem.setAttribute('value', "<none>"); // sets menuitem label
		emptyMenuItem.setAttribute('label', stringBundle.getString('noDetectedProfileSelected')); // sets menuitem label
		detectedProfileMenuPopUp.appendChild(emptyMenuItem); // adds item into menulist
	}
}

function fillDetectedProfileMenuList()
{
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");
	var detectedProfileMenuPopUp = document.getElementById("detectedProfileMenuPopUp");

	if ( (detectionRulesListBox != null) && (detectedProfileMenuList != null) && (detectedProfileMenuPopUp != null) ) { // (JSCTSABT)
		var newMenuItem = null;

		for ( var idx = 0 ; idx < profilesSettingsList.length ; idx++ ) { // for each profile
			newMenuItem = document.createElement("menuitem"); // creates a new menuitem

			newMenuItem.setAttribute('value', profilesSettingsList[idx].id); // sets menuitem value (usefull for storing settings)
			newMenuItem.setAttribute('label', profilesSettingsList[idx].name); // sets menuitem label

			detectedProfileMenuPopUp.appendChild(newMenuItem);
		}
	}
}

function checkIPAddress(ipAddress)
{
	var okFlag = true;

	// '^': start of string
	// 
	// '$': end of string
	// var reIPAddress = new RegExp("^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}?(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$", "i");
	var reIPAddress = new RegExp("^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$", "i");

	okFlag = ( ipAddress.match(reIPAddress) != null );

	if ( !okFlag ) {
		GetSelectedMails.displayAlertDialog(stringBundle.getString('ipAddressCheckSta') + " '" + ipAddress + "' " + stringBundle.getString('ipAddressCheckEnd'));

		sendMessageToConsole("options.checkIPAddress", "IP address '" + ipAddress + "' is invalid", "warning");
	}

	return okFlag;
}

function checkIPAddressesInterval(startIP, endIP)
{
	var okFlag = true;

	// '^': start of string
	// 
	// '$': end of string
	var reIPAddress = new RegExp("^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$", "i");

	var startIPParts = startIP.match(reIPAddress);
	var endIPParts = endIP.match(reIPAddress);

	if ( (startIPParts != null) && (endIPParts != null) ) {
		for ( var idx = 1 ; (idx <= 4) && okFlag ; idx++ ) {
			if ( parseInt(startIPParts[idx]) > parseInt(endIPParts[idx]) ) {
				GetSelectedMails.displayAlertDialog(stringBundle.getString('ipAddressesIntervalCheckSta') + idx + " " + stringBundle.getString('ipAddressesIntervalCheckEnd'));
				okFlag = false;
			}
		}
	}

	return okFlag;
}

function checkIPAddressesIntervalDoublon(startIP, endIP, selectedDetectionRuleIdx)
{
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");
	var okFlag = true;

	// search of new detection rule into current detection rules list
	for ( var idx = 0 ; (idx < detectionRulesListBox.getRowCount()) && okFlag ; idx++ ) { // for each detection rule of detection rules listbox
		if ( idx != selectedDetectionRuleIdx ) {
			if ( (startIP == detectionRulesListBox.getItemAtIndex(idx).children[0].getAttribute('label'))
				 || (endIP == detectionRulesListBox.getItemAtIndex(idx).children[1].getAttribute('label')) )
			{ // if detection rules listbox already contains current detection rule
				okFlag = false;
			}

			if ( !okFlag ) {
				GetSelectedMails.displayAlertDialog(stringBundle.getString('detectionRuleDoublonSta')
													+ "[" + startIP + ";" + endIP + "] => " + detectedProfileMenuList.label
													+ stringBundle.getString('detectionRuleDoublonMid')
													+ "[" + detectionRulesListBox.getItemAtIndex(idx).children[0].getAttribute('label') + ";" + detectionRulesListBox.getItemAtIndex(idx).children[1].getAttribute('label') + "] " + " => " + detectionRulesListBox.getItemAtIndex(idx).children[2].getAttribute('label')
													+ stringBundle.getString('detectionRuleDoublonEnd'));

				sendMessageToConsole("options.checkIPAddressesIntervalDoublon", "Detection rule '[" + startIP + ";" + endIP + "]' is in conflict", "warning");
			}
		}
	}

	return okFlag;
}

function saveDetectionRules()
{
	var detectionRulesStr = "";
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	if ( (detectionRulesListBox != null) && detectionRulesListBoxChanged ) { // if any change has been made to detection rules list
		detectionRulesArray = new Array();

		// creation of detection rules string
		for ( var idx = 0 ; idx < detectionRulesListBox.getRowCount() ; idx++ ) { // for each detection rule of detection rules listbox
			detectionRulesArray.push(new GetSelectedMails.DetectionRule(
				detectionRulesListBox.getItemAtIndex(idx).children[0].getAttribute('label'),
				detectionRulesListBox.getItemAtIndex(idx).children[1].getAttribute('label'),
				detectionRulesListBox.getItemAtIndex(idx).children[2].getAttribute('value'),
				detectionRulesListBox.getItemAtIndex(idx).children[3].children[0].checked));
		}
		detectionRulesStr = GetSelectedMails.JSONstringify(detectionRulesArray, GetSelectedMails.preProcessSaveSettings, new Array("sIP", "eIP", "pId"));

		sendMessageToConsole("options.saveDetectionRules", "Detection rules list has been modified: " + detectionRulesStr);

		detectionRulesListBoxChanged = false;
	}
}

function addDetectionRule(startIP, endIP, profileId, profileName, onOff, init)
{
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	// add of detection rule
	if ( detectionRulesListBox != null ) { // (JSCTSABT)
		if ( startIP != "" ) {
			var okFlag = true;

			if ( endIP == "" ) {
				endIP = startIP;
			}

			okFlag = okFlag && checkIPAddress(startIP); // checks start IP address
			okFlag = okFlag && checkIPAddress(endIP); // checks end IP address

			okFlag = okFlag && checkIPAddressesInterval(startIP, endIP); // checks interval

			okFlag = okFlag && checkIPAddressesIntervalDoublon(startIP, endIP, -1); // checks doublon

			if ( okFlag ) { // if detection rule is valid
				// insertion of new detection rule in listbox
				var newRow = null;
				var newCell = null;
				var newCheckBox = null;

				newRow = document.createElement('listitem'); // adds detection rule to detection rules listbox
				newRow.setAttribute('id', "detectionRuleRow-" + detectionRulesListBox.getRowCount()); // sets id
				newRow.setAttribute('allowevents', true); // allows to transfer events to embedded objects

				// start IP
				newCell = document.createElement('listcell');
				newCell.setAttribute('label', startIP);
				newRow.appendChild(newCell); // adds start ip

				// end IP
				newCell = document.createElement('listcell');
				newCell.setAttribute('label', endIP);
				newRow.appendChild(newCell); // adds end ip

				// profile
				newCell = document.createElement('listcell');
				newCell.setAttribute('value', profileId);
				newCell.setAttribute('label', profileName);
				newRow.appendChild(newCell); // adds profile

				// 'enabled' checkbox
				newCell = document.createElement('listcell');
				newCheckBox = document.createElement('checkbox');
				newCheckBox.setAttribute('id', "enableDetectionRuleCheckBox-" + detectionRulesListBox.getRowCount()); // sets id
				newCheckBox.setAttribute('checked', onOff);
				newCheckBox.addEventListener("command", function() { onSelectEnableDetectionRuleCheckBox(this.id, false); }, false); // sets related action

				newCell.appendChild(newCheckBox);
				newRow.appendChild(newCell); // adds 'enabled' value

				detectionRulesListBox.appendChild(newRow); // adds char detection rule to detection rules listbox

				onSelectEnableDetectionRuleCheckBox(newCheckBox.id, init);

				// update of GUI
				var selIdx = detectionRulesListBox.getRowCount() - 1;
				detectionRulesListBox.ensureIndexIsVisible(selIdx); // ensures item is visible

				if ( !init ) {
					detectionRulesListBox.selectedIndex = selIdx;
				}

				sendMessageToConsole("options.addDetectionRule", "Detection rule '[" + startIP + ";" + endIP + "] => " + profileId + "' has been added");
			}
		}
	}
}

function initializeDetectionRulesList()
{
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	// clearance of detection rules list
	if ( detectionRulesListBox != null ) { // (JSCTSABT)
		for ( var idx = detectionRulesListBox.getRowCount() - 1 ; idx >= 0 ; idx-- ) { // for each detection rule of the listbox (reverse order)
			detectionRulesListBox.removeItemAt(idx); // removes last item
		}
	}

	// filling of detection rules list
	var detectedProfileMenuPopUp = document.getElementById("detectedProfileMenuPopUp");

	if ( detectedProfileMenuPopUp != null ) { // (JSCTSABT)
		var profileId = "";
		var profileName = "";
		var found = false;

		for ( var idx = 0 ; idx < detectionRulesArray.length ; idx++ ) { // for each detection rule
			profileId = "<none>";
			profileName = stringBundle.getString('noDetectedProfileSelected');
			found = false;

			for ( var jdx = 0 ; (jdx < profilesSettingsList.length) && !found ; jdx++ ) { // for each profile
				if ( profilesSettingsList[jdx].id == detectionRulesArray[idx].pId ) {
					profileId = profilesSettingsList[jdx].id;
					profileName = profilesSettingsList[jdx].name;

					found = true;
				}
			}

			addDetectionRule(detectionRulesArray[idx].sIP, detectionRulesArray[idx].eIP, profileId, profileName, detectionRulesArray[idx].on, true);
		}
	}

	sendMessageToConsole("options.initializeDetectionRulesList", idx + " detection rules have been loaded");
}

function onClickDetectionRuleAddButton()
{
	var startIPTextBox = document.getElementById("startIPTextBox");
	var endIPTextBox = document.getElementById("endIPTextBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");

	if ( (startIPTextBox != null) && (endIPTextBox != null) && (detectedProfileMenuList != null) ) { // (JSCTSABT)
		addDetectionRule(startIPTextBox.value, endIPTextBox.value, detectedProfileMenuList.value, detectedProfileMenuList.label, true, false);

		detectionRulesListBoxChanged = true;
		saveDetectionRules();

		startIPTextBox.focus(); // brings back focus to input textbox
	}
}

function onClickDetectionRuleModifyButton()
{
	var startIPTextBox = document.getElementById("startIPTextBox");
	var endIPTextBox = document.getElementById("endIPTextBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");

	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	if ( (startIPTextBox != null) && (endIPTextBox != null) && (detectedProfileMenuList != null) && (detectionRulesListBox != null) ) { // (JSCTSABT)
		var startIP = startIPTextBox.value;
		var endIP = endIPTextBox.value;

		if ( startIP != "" ) {
			var okFlag = true;

			if ( endIP == "" ) {
				endIP = startIP;
			}

			okFlag = okFlag && checkIPAddress(startIP); // checks start IP address
			okFlag = okFlag && checkIPAddress(endIP); // checks end IP address

			okFlag = okFlag && checkIPAddressesInterval(startIP, endIP); // checks interval

			okFlag = okFlag && checkIPAddressesIntervalDoublon(startIP, endIP, selectedDetectionRuleIdx); // checks doublon

			if ( okFlag ) { // if detection rule is valid
				// update of detection rule
				detectionRulesListBox.getItemAtIndex(selectedDetectionRuleIdx).children[0].setAttribute('label', startIP);
				detectionRulesListBox.getItemAtIndex(selectedDetectionRuleIdx).children[1].setAttribute('label', endIP);
				detectionRulesListBox.getItemAtIndex(selectedDetectionRuleIdx).children[2].setAttribute('value', detectedProfileMenuList.value);
				detectionRulesListBox.getItemAtIndex(selectedDetectionRuleIdx).children[2].setAttribute('label', detectedProfileMenuList.label);

				// update of GUI
				detectionRulesListBox.ensureIndexIsVisible(selectedDetectionRuleIdx); // ensures item is visible
				detectionRulesListBox.selectedIndex = selectedDetectionRuleIdx;

				sendMessageToConsole("options.onClickDetectionRuleModifyButton", "Detection rule '[" + startIP + ";" + endIP + "] => " + detectedProfileMenuList.label + "' has been modified");

				detectionRulesListBoxChanged = true;
				saveDetectionRules();
			}
		}

		startIPTextBox.focus(); // brings back focus to input textbox
	}
}

function onClickDetectionRuleUpButton()
{
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	if ( detectionRulesListBox != null ) { // (JSCTSABT)
		if ( (selectedDetectionRuleIdx != -1) && (selectedDetectionRuleIdx > 0) ) { // if an item is selected and is not the first one
			swapDetectionRuleButton(detectionRulesListBox, selectedDetectionRuleIdx, selectedDetectionRuleIdx - 1, "up");
		}
	}
}

function onClickDetectionRuleDownButton()
{
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	if ( detectionRulesListBox != null ) { // (JSCTSABT)
		if ( (selectedDetectionRuleIdx != -1) && (selectedDetectionRuleIdx < detectionRulesListBox.getRowCount() - 1) ) { // if an item is selected and is not the last one
			swapDetectionRuleButton(detectionRulesListBox, selectedDetectionRuleIdx, selectedDetectionRuleIdx + 1, "down");
		}
	}
}

function swapDetectionRuleButton(detectionRulesListBox, detectionRule1Idx, detectionRule2Idx, msg)
{
	// update of listbox
	var row1 = detectionRulesListBox.getItemAtIndex(detectionRule1Idx);
	var row2 = detectionRulesListBox.getItemAtIndex(detectionRule2Idx);

	// saving of moved item
	var tmpStartIP = row1.children[0].getAttribute('label');
	var tmpEndIP = row1.children[1].getAttribute('label');
	var tmpProfileId = row1.children[2].getAttribute('value');
	var tmpProfileName = row1.children[2].getAttribute('label');
	var tmpOn = row1.children[3].children[0].checked;

	// crushing of moved item with other item
	row1.children[0].setAttribute('label', row2.children[0].getAttribute('label'));
	row1.children[1].setAttribute('label', row2.children[1].getAttribute('label'));
	row1.children[2].setAttribute('value', row2.children[2].getAttribute('value'));
	row1.children[2].setAttribute('label', row2.children[2].getAttribute('label'));
	row1.children[3].children[0].checked = row2.children[3].children[0].checked;

	onSelectEnableDetectionRuleCheckBox("enableDetectionRuleCheckBox-" + detectionRule1Idx, true);

	// restoration of saved item
	row2.children[0].setAttribute('label', tmpStartIP);
	row2.children[1].setAttribute('label', tmpEndIP);
	row2.children[2].setAttribute('value', tmpProfileId);
	row2.children[2].setAttribute('label', tmpProfileName);
	row2.children[3].children[0].checked = tmpOn;

	onSelectEnableDetectionRuleCheckBox("enableDetectionRuleCheckBox-" + detectionRule2Idx, true);

	detectionRulesListBox.ensureIndexIsVisible(detectionRule2Idx); // ensures item is visible
	detectionRulesListBox.selectedIndex = detectionRule2Idx; // selects item

	sendMessageToConsole("options.swapDetectionRuleButton", "Detection rule '[" + tmpStartIP + ";" + tmpEndIP + "] => " + tmpProfileId + "' has been moved " + msg);

	detectionRulesListBoxChanged = true;
	saveDetectionRules();
	// detectionRule1Idx = detectionRule2Idx;
}

function onClickDetectionRuleRemoveButton()
{
	var startIPTextBox = document.getElementById("startIPTextBox");
	var endIPTextBox = document.getElementById("endIPTextBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");

	var detectionRulesListBox = document.getElementById("detectionRulesListBox");

	if ( (startIPTextBox != null) && (endIPTextBox != null) && (detectedProfileMenuList != null) && (detectionRulesListBox != null) ) { // if textboxes are not empty
		var selIdx = detectionRulesListBox.selectedIndex;

		if ( selIdx != -1 ) { // if an item is selected
			var startIP = detectionRulesListBox.getItemAtIndex(selIdx).children[0].getAttribute('label');
			var endIP = detectionRulesListBox.getItemAtIndex(selIdx).children[1].getAttribute('label');

			// removal of item
			detectionRulesListBox.removeItemAt(selIdx);

			// selection of one of other left items
			if ( detectionRulesListBox.getRowCount() > 0 ) { // if there is one item left
				if ( selIdx == detectionRulesListBox.getRowCount() ) { // if removed item was the last one in the list
					selIdx--; // chooses the current last item (was formerly the penultimate one)
				}

				detectionRulesListBox.selectedIndex = selIdx; // selects it
			}
			else {
				initializeDetectionRuleInputBoxes();
			}

			sendMessageToConsole("options.onClickDetectionRuleRemoveButton", "Detection rule '[" + startIP + ";" + endIP + "] => " + detectionRulesListBox.getItemAtIndex(selIdx).children[2].getAttribute('label') + "' has been removed");

			detectionRulesListBoxChanged = true;
			saveDetectionRules();
		}
	}
}

function onSelectEnableDetectionRuleCheckBox(selId, init)
{
	var enabledCheckBox = document.getElementById(selId);

	var rowId = "detectionRuleRow-" + selId.substring(selId.indexOf("-") + 1);
	var detectionRuleRow = document.getElementById(rowId);

	if ( (enabledCheckBox != null) && (detectionRuleRow != null) ) { // (JSCTSABT)
		detectionRuleRow.children[0].setAttribute('disabled', !enabledCheckBox.checked);
		detectionRuleRow.children[1].setAttribute('disabled', !enabledCheckBox.checked);
		detectionRuleRow.children[2].setAttribute('disabled', !enabledCheckBox.checked);

		if ( !init ) {
			detectionRulesListBoxChanged = true;
			saveDetectionRules();
		}
	}
}

function onSelectDetectionRule(selIdx)
{
	var detectionRulesListBox = document.getElementById("detectionRulesListBox");
	var startIPTextBox = document.getElementById("startIPTextBox");
	var endIPTextBox = document.getElementById("endIPTextBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");

	if ( (detectionRulesListBox != null) && (startIPTextBox != null) && (endIPTextBox != null) && (detectedProfileMenuList != null) ) { // (JSCTSABT)
		var selRow = detectionRulesListBox.selectedItem;

		if ( selRow != null ) { // if an item is selected
			// copy of selected detection rule details into input textboxes and checkboxes
			startIPTextBox.value = selRow.children[0].getAttribute('label');
			endIPTextBox.value = selRow.children[1].getAttribute('label');
			detectedProfileMenuList.value = selRow.children[2].getAttribute('value');

			selectedDetectionRuleIdx = detectionRulesListBox.selectedIndex;
		}
		else { // if no item is selected
			initializeDetectionRuleInputBoxes();
		}

		detectionRulesListBox.focus(); // brings back focus to listbox
	}
}

function initializeDetectionRuleInputBoxes()
{
	var startIPTextBox = document.getElementById("startIPTextBox");
	var endIPTextBox = document.getElementById("endIPTextBox");
	var detectedProfileMenuList = document.getElementById("detectedProfileMenuList");

	if ( (startIPTextBox != null) && (endIPTextBox != null) && (detectedProfileMenuList != null) ) { // if textboxes are not empty
		document.getElementById("startIPTextBox").value = ""; // clears input textbox
		document.getElementById("endIPTextBox").value = ""; // clears input textbox

		document.getElementById("detectedProfileMenuList").selectedIndex = 0; // resets menulist
	}
}

function onClickAutomaticDetectionHelpButton()
{
	GetSelectedMails.displayMessageDialog(stringBundle.getString('automaticDetectionHelp'));
}

// 'miscellaneous' functions
function onClickDelayEnabledCheckBox(state)
{
	document.getElementById("delayTextBox").disabled = !state;
	document.getElementById("delayLabel").disabled = !state;
	document.getElementById("delayOnlyDeferredAccountsCheckBox").disabled = !state;
}

function onClickExportProfilesButton()
{
	var filePicker = Components.classes["@mozilla.org/filepicker;1"]
						.createInstance(Components.interfaces.nsIFilePicker);
	var homeDir = null;
	var defaultName = GetSelectedMails.temporaryRoot + "_profiles.txt";

	homeDir = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("Home", Components.interfaces.nsIFile);

	filePicker.appendFilter("Profiles files", "*.txt");
	filePicker.init(window, stringBundle.getString('chooseProfilesFile'), Components.interfaces.nsIFilePicker.modeSave);
	filePicker.displayDirectory = homeDir;
	filePicker.defaultString = defaultName;

	// nsIFilePicker.show() is deprecated for TB >= v17
	// nsIFilePicker.open() has been introduced in TB v17 but behaves awkwardly for TB v17.* (callback function has to be a component with a method named 'done', exception message is: [Exception... "'Javascript component does not have a method named: "done"' when calling method: nsIFilePickerShownCallback::done" nsresult: "0805700300 (NS_ERROR_XPC_JSOBJECT_HAS_NO_FUNCTION_NAMED)" location: "<unknown>" data: no]
	if ( GetSelectedMails.isTBVersionEqualOrHigherThan("18.0a1") ) {
		filePicker.open(function() {
			onClickExportProfilesButton2(filePicker);
		});
	}
	else {
		var filePickerReturnVal = filePicker.show();

		if ( (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnOK) || (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnReplace) ) {
			onClickExportProfilesButton2(filePicker);
		}
	}
}

function onClickExportProfilesButton2(filePicker)
{
	if ( filePicker.file != null ) { // if a file has been chosen
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService)
					.getBranch("extensions." + GetSelectedMails.addOnName + ".");

		var settingName = "profilesSettings";

		try {
			prefs.QueryInterface(Components.interfaces.nsIPrefBranch);

			// check of existence of profiles file
			var settingsFile = GetSelectedMails.VirtualLocalFile();
			settingsFile.initWithPath(filePicker.file.path);

			if ( !settingsFile.exists() ) {
				settingsFile.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
			}

			// writing of profiles into file
			var profilesFileStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
									.createInstance(Components.interfaces.nsIFileOutputStream);

			profilesFileStream.init(settingsFile, GetSelectedMails.PR_WRONLY | GetSelectedMails.PR_TRUNCATE, 0664, 0);

			var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
							.createInstance(Components.interfaces.nsIConverterOutputStream);
			converter.init(profilesFileStream, "UTF-8", 0, 0);

			converter.writeString(prefs.getCharPref(settingName) + "\n");

			converter.close(); // closes profilesFileStream too
		}
		catch ( err ) {
			sendMessageToConsole("options.onClickExportProfilesButton2", "Error while writing setting '" + settingName + "' to file (" + err + ")", "error");
		}
	}
}

function onClickImportProfilesButton()
{
	var filePicker = Components.classes["@mozilla.org/filepicker;1"]
						.createInstance(Components.interfaces.nsIFilePicker);
	var homeDir = null;
	var defaultName = GetSelectedMails.temporaryRoot + "_profiles.txt";

	homeDir = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("Home", Components.interfaces.nsIFile);

	filePicker.appendFilter("Profiles files", "*.txt");
	filePicker.appendFilter("All files", "*.*");
	filePicker.init(window, stringBundle.getString('chooseProfilesFile'), Components.interfaces.nsIFilePicker.modeOpen);
	filePicker.displayDirectory = homeDir;
	filePicker.defaultString = defaultName;

	// nsIFilePicker.show() is deprecated for TB >= v17
	// nsIFilePicker.open() has been introduced in TB v17 but behaves awkwardly for TB v17.* (callback function has to be a component with a method named 'done', exception message is: [Exception... "'Javascript component does not have a method named: "done"' when calling method: nsIFilePickerShownCallback::done" nsresult: "0805700300 (NS_ERROR_XPC_JSOBJECT_HAS_NO_FUNCTION_NAMED)" location: "<unknown>" data: no]
	if ( GetSelectedMails.isTBVersionEqualOrHigherThan("18.0a1") ) {
		filePicker.open(function() {
			onClickImportProfilesButton2(filePicker);
		});
	}
	else {
		var filePickerReturnVal = filePicker.show();

		if ( (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnOK) || (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnReplace) ) {
			onClickImportProfilesButton2(filePicker);
		}
	}
}

function onClickImportProfilesButton2(filePicker)
{
	if ( filePicker.file != null ) { // if a file has been chosen
		var settingName = "profilesSettings";
		var importedProfilesSettings = "";
		var importedProfilesSettingsList = new Array();

		try {
			// check of existence of profiles file
			var settingsFile = GetSelectedMails.VirtualLocalFile();
			settingsFile.initWithPath(filePicker.file.path);

			if ( settingsFile.exists() ) {
				// reading of profiles from file
				var profilesFileStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
										.createInstance(Components.interfaces.nsIFileInputStream);

				profilesFileStream.init(settingsFile, GetSelectedMails.PR_RDONLY, 0444, 0);

				var converter = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
								.createInstance(Components.interfaces.nsIConverterInputStream);
				converter.init(profilesFileStream, "UTF-8", 0, 0);
				converter.QueryInterface(Components.interfaces.nsIUnicharLineInputStream);

				var line = {};

				if (converter instanceof Components.interfaces.nsIUnicharLineInputStream) {
					converter.readLine(line);

					importedProfilesSettings = line.value;
					if ( importedProfilesSettings == "" ) {
						importedProfilesSettings = "[]";
					}
					importedProfilesSettingsList = GetSelectedMails.JSONparse(importedProfilesSettings, GetSelectedMails.preProcessLoadProfileSettings, new Array("name", "title")); // parses profiles settings as JSON string

					sendMessageToConsole("options.onClickImportProfilesButton2", importedProfilesSettings);
					sendMessageToConsole("options.onClickImportProfilesButton2", importedProfilesSettingsList.length + " profiles have been read from import file");

					var msg1 = stringBundle.getString('importProfilesConfirm1Sta') + " " + importedProfilesSettingsList.length + " " + stringBundle.getString('importProfilesConfirm1End');

					if ( importedProfilesSettingsList.length > 0 ) { // if a profile has actually been found
						msg1 += "\r\n" + stringBundle.getString('importProfilesConfirm2');

						// search for maximum profile index ("p" + number)
						var profileIdRgx = null;
						var maxProfileIdx = 0;

						for ( var idx = 0 ; (idx < profilesSettingsList.length) ; idx++ ) { // for each profile
							profileIdRgx = profilesSettingsList[idx].id.match(new RegExp("^p([0-9]+)$"));

							if ( profileIdRgx != null ) {
								if ( parseInt(maxProfileIdx) < parseInt(profileIdRgx[1]) ) {
									maxProfileIdx = profileIdRgx[1];
								}
							}
						}

						maxProfileIdx++;
						var importedProfilesCount = 0;

						if ( GetSelectedMails.displayConfirmDialog(msg1) ) { // displays a general confirmation dialog, and if 'ok' is selected
							var msg2 = "";

							for ( var idx in importedProfilesSettingsList ) { // for each profile
								msg2 = stringBundle.getString('importProfilesConfirm3Sta') + importedProfilesSettingsList[idx].name + stringBundle.getString('importProfilesConfirm3End');

								if ( GetSelectedMails.displayConfirmDialog(msg2) ) { // displays an import confirmation dialog, and if 'ok' is selected
									importedProfilesCount++;
									importedProfilesSettingsList[idx].id = "p" + maxProfileIdx++; // changes imported profile index

									profilesSettingsList.push(new GetSelectedMails.ProfileSettings(importedProfilesSettingsList[idx]));

									sendMessageToConsole("options.onClickImportProfilesButton2", "Profile " + importedProfilesSettingsList[idx].id + " / '" + importedProfilesSettingsList[idx].name + "' has been imported");
								}
							}

							// updates graphical elements
							reinitializeMenuLists();
							fillMenuLists();
							resetDetectedProfileMenuList();
							loadProfile(currentProfileIdx);

							sendMessageToConsole("options.onClickImportProfilesButton2", importedProfilesCount + " profiles have been imported");

							var msg3 = stringBundle.getString('importProfilesConfirm4Sta') + " " + importedProfilesCount + " " + stringBundle.getString('importProfilesConfirm4End');
							GetSelectedMails.displayMessageDialog(msg3);
						}
					}
					else { // if no profile has been found in import file
						GetSelectedMails.displayMessageDialog(msg1);
					}
				}
				else { // if contents of file cannot be read
					sendMessageToConsole("options.onClickImportProfilesButton2", "Contents of file '" + filePicker.file.path + "' cannot be read", "error");
				}

				converter.close(); // closes profilesFileStream too
			}
			else { // if import file does not exist
				sendMessageToConsole("options.onClickImportProfilesButton2", "File '" + filePicker.file.path + "' does not exist or cannot be read", "error");
			}
		}
		catch ( err ) {
			sendMessageToConsole("options.onClickImportProfilesButton2", "Error while reading setting '" + settingName + "' from file '" + filePicker.file.path + "' (" + err + ")", "error");
		}
	}
}

function onClickCleanAccountsButton()
{
	var tempObj = null;

	for ( var idx in profilesSettingsList ) {
		// cleaning of accounts selection
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].accounts[accountKey];
			}
		}

		profilesSettingsList[idx].accounts = tempObj;

		// cleaning of headers fetching
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].hdrs[accountKey];
			}
		}

		profilesSettingsList[idx].hdrs = tempObj;

		// cleaning of headers fetching default
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].hdrsDflt[accountKey];
			}
		}

		profilesSettingsList[idx].hdrsDflt = tempObj;

		// cleaning of server
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].srv[accountKey];
			}
		}

		profilesSettingsList[idx].srv = tempObj;

		// cleaning of server name
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].srvName[accountKey];
			}
		}

		profilesSettingsList[idx].srvName = tempObj;

		// cleaning of server default
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].srvDflt[accountKey];
			}
		}

		profilesSettingsList[idx].srvDflt = tempObj;

		// cleaning of port
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].prt[accountKey];
			}
		}

		profilesSettingsList[idx].prt = tempObj;

		// cleaning of port number
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].prtNmbr[accountKey];
			}
		}

		profilesSettingsList[idx].prtNmbr = tempObj;

		// cleaning of port default
		tempObj = {};

		for ( var accountKey in profilesSettingsList[idx].accounts ) {
			if ( accountKeysList[accountKey] != null ) {
				tempObj[accountKey] = profilesSettingsList[idx].prtDflt[accountKey];
			}
		}

		profilesSettingsList[idx].prtDflt = tempObj;
	}

	sendMessageToConsole("options.onClickCleanAccountsButton", "Accounts list has been cleaned from unavailable accounts");
}

function onClickDebugModeCheckBox(state)
{
	document.getElementById("debugModeToFileCheckBox").disabled = !state;
	if ( !state ) {
		document.getElementById("debugModeToFileTextBox").disabled = true;
		document.getElementById("debugModeToFileButton").disabled = true;
	}
	else {
		document.getElementById("debugModeToFileTextBox").disabled = !document.getElementById("debugModeToFileCheckBox").checked;
		document.getElementById("debugModeToFileButton").disabled = !document.getElementById("debugModeToFileCheckBox").checked;
	}
}

function onClickDebugModeToFileCheckBox(state)
{
	document.getElementById("debugModeToFileTextBox").disabled = !state;
	document.getElementById("debugModeToFileButton").disabled = !state;
}

function onClickDebugModeToFileButton()
{
	var filePicker = Components.classes["@mozilla.org/filepicker;1"]
						.createInstance(Components.interfaces.nsIFilePicker);
	var homeDir = null;
	var defaultName = "";

	var debugFileName = document.getElementById("debugModeToFileTextBox").value;

	if ( debugFileName != "" ) {
		try {
			homeDir = GetSelectedMails.VirtualLocalFile();
			homeDir.initWithPath(debugFileName);
			defaultName = homeDir.leafName; // should be called before 'homeDir = homeDir.parent;'
			homeDir = homeDir.parent;
		}
		catch ( err ) {
			debugFileName = "";
		}
	}

	if ( debugFileName == "" ) {
		homeDir = Components.classes["@mozilla.org/file/directory_service;1"]
					.getService(Components.interfaces.nsIProperties)
					.get("Home", Components.interfaces.nsIFile);

		defaultName = GetSelectedMails.temporaryRoot + "_logfile.log";
	}

	filePicker.appendFilter("Log files", "*.log;*.txt");
	filePicker.init(window, stringBundle.getString('chooseDebugLogFile'), Components.interfaces.nsIFilePicker.modeSave);
	filePicker.displayDirectory = homeDir;
	filePicker.defaultString = defaultName;

	// nsIFilePicker.show() is deprecated for TB >= v17
	// nsIFilePicker.open() has been introduced in TB v17 but behaves awkwardly for TB v17.* (callback function has to be a component with a method named 'done', exception message is: [Exception... "'Javascript component does not have a method named: "done"' when calling method: nsIFilePickerShownCallback::done" nsresult: "0805700300 (NS_ERROR_XPC_JSOBJECT_HAS_NO_FUNCTION_NAMED)" location: "<unknown>" data: no]
	if ( GetSelectedMails.isTBVersionEqualOrHigherThan("18.0a1") ) {
		filePicker.open(function() {
			onClickDebugModeToFileButton2(filePicker);
		});
	}
	else {
		var filePickerReturnVal = filePicker.show();

		if ( (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnOK) || (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnReplace) ) {
			onClickDebugModeToFileButton2(filePicker);
		}
	}
}

function onClickDebugModeToFileButton2(filePicker)
{
	if ( filePicker.file != null ) {
		document.getElementById("debugModeToFileTextBox").value = filePicker.file.path;
	}
}

function onClickResetDefaultsButton()
{
	if ( GetSelectedMails.displayConfirmDialog(stringBundle.getString('beforeResetDefaults')) ) { // displays a confirmation dialog, and if 'ok' is selected
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService)
						.getBranch(null);

		prefs.deleteBranch("extensions." + GetSelectedMails.addOnName);

		GetSelectedMails.displayAlertDialog(stringBundle.getString('afterResetDefaults'));

		window.close();
	}
}

function onClickExportSettingsButton()
{
	var filePicker = Components.classes["@mozilla.org/filepicker;1"]
						.createInstance(Components.interfaces.nsIFilePicker);
	var homeDir = null;
	var defaultName = GetSelectedMails.temporaryRoot + "_settings.txt";

	homeDir = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("Home", Components.interfaces.nsIFile);

	filePicker.appendFilter("Settings files", "*.txt");
	filePicker.init(window, stringBundle.getString('chooseSettingsFile'), Components.interfaces.nsIFilePicker.modeSave);
	filePicker.displayDirectory = homeDir;
	filePicker.defaultString = defaultName;

	// nsIFilePicker.show() is deprecated for TB >= v17
	// nsIFilePicker.open() has been introduced in TB v17 but behaves awkwardly for TB v17.* (callback function has to be a component with a method named 'done', exception message is: [Exception... "'Javascript component does not have a method named: "done"' when calling method: nsIFilePickerShownCallback::done" nsresult: "0805700300 (NS_ERROR_XPC_JSOBJECT_HAS_NO_FUNCTION_NAMED)" location: "<unknown>" data: no]
	if ( GetSelectedMails.isTBVersionEqualOrHigherThan("18.0a1") ) {
		filePicker.open(function() {
			onClickExportSettingsButton2(filePicker);
		});
	}
	else {
		var filePickerReturnVal = filePicker.show();

		if ( (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnOK) || (filePickerReturnVal == Components.interfaces.nsIFilePicker.returnReplace) ) {
			onClickExportSettingsButton2(filePicker);
		}
	}
}

function onClickExportSettingsButton2(filePicker)
{
	if ( filePicker.file != null ) { // if a file has been chosen
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService)
					.getBranch("extensions." + GetSelectedMails.addOnName + ".");
		var branch = prefs.QueryInterface(Components.interfaces.nsIPrefBranch);
		var settings = branch.getChildList("", {});

		var settingName = "";
		var settingVal = null;

		try {
			// check of existence of settings file
			var settingsFile = GetSelectedMails.VirtualLocalFile();
			settingsFile.initWithPath(filePicker.file.path);

			if ( !settingsFile.exists() ) {
				settingsFile.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
			}

			// writing of settings into file
			var settingsFileStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
									.createInstance(Components.interfaces.nsIFileOutputStream);

			settingsFileStream.init(settingsFile, GetSelectedMails.PR_WRONLY | GetSelectedMails.PR_TRUNCATE, 0664, 0);

			var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
							.createInstance(Components.interfaces.nsIConverterOutputStream);
			converter.init(settingsFileStream, "UTF-8", 0, 0);

			for ( var settingId in settings ) { // for each settings
				settingName = settings[settingId];
				
				switch ( branch.getPrefType(settingName) ) {
					// PREF_STRING = 32
					// PREF_INT = 64
					// PREF_BOOL = 128
					// PREF_INVALID = ?
					case 32: settingVal = "'" + prefs.getCharPref(settingName) + "'"; break;
					case 64: settingVal = prefs.getIntPref(settingName); break;
					case 128: settingVal = prefs.getBoolPref(settingName); break;
					default: settingVal = null;
				}

				if ( settingVal != null ) {
					if ( GetSelectedMails.exportSettingsMode == "PREFS" ) {
						converter.writeString("user_pref(\"extensions." + GetSelectedMails.addOnName + "." + settingName + "\", " + settingVal + ");\n");
					}
					else {
						converter.writeString(settingName + "=" + settingVal + "\n");
					}
				}
				else {
					sendMessageToConsole("options.onClickExportSettingsButton2", "Type of setting '" + settingName + "' = '" + branch.getPrefType(settingName) + "' is not handled", "error");
				}
			}

			converter.close(); // closes settingsFileStream too
		}
		catch ( err ) {
			sendMessageToConsole("options.onClickExportSettingsButton2", "Error while writing setting '" + settingName + "' to file (" + err + ")", "error");
		}
	}
}
